/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_BUFFER_H_INCLUDED)
#define HARK_BASE_BUFFER_H_INCLUDED 1

#include "common.h"

#include "Object.h"
#include "ObjectRef.h"
#include "Exception.h"
#include <typeinfo>
#include <vector>

namespace HARK
{
    class Buffer : public Object
    {
    public:
	Buffer(int bLength);

	Buffer(const Buffer&);

	ObjectRef &get(int ind) const;
	ObjectRef &operator[] (int ind);
	int isValid(int ind) const;
	void printOn(std::ostream &out = std::cout) const;

	int getCurrentPos();

    protected:
	mutable std::vector<ObjectRef> data;
	mutable std::vector<int>       flags;
	int         bufferLength;
	mutable int bufferPos;
	mutable int currentPos;

    };

    class BufferException : public BaseException
    {
    public:
	BufferException(const Buffer *_buffer, std::string _message, int _element);
	virtual void print(std::ostream &out = std::cerr) const;

    protected:
	const Buffer *buffer;
	std::string message;
	int element;
    };
}

#endif

/* end of file */
