/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_COLLECTOR_H_INCLUDED)
#define HARK_BASE_COLLECTOR_H_INCLUDED 1

#include "common.h"

#include "Node.h"
#include "Exception.h"
#include <map>

namespace HARK
{
    class Collector : public Node
    {
    protected:
	Collector();

    public:
	Collector(const std::string &nodeName, const ParameterSet &params);

	virtual void initialize();

	virtual ObjectRef getOutput(int output_id, int count);

	virtual ObjectRef getOutputNamed (const std::string &outputName, int count);

	virtual bool hasOutput(int output_id) const;

	virtual void request(int outputID, const ParameterSet &req);

	virtual void requestAll(const ParameterSet &req);

    protected:
	virtual int translateInput(const std::string &inputName);
	virtual int translateOutput(const std::string &inputName);

    };
}

#endif

/* end of file */
