/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_EXCEPTION_H_INCLUDED)
#define HARK_BASE_EXCEPTION_H_INCLUDED 1

#include "common.h"

#include <iostream>
#include <string>
#include "BaseException.h"

namespace HARK
{
    class NodeNotFoundException : public BaseException
    {
    public:
	NodeNotFoundException(std::string name);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	std::string nodeName;
    };

    class  NoSinkNodeException : public BaseException
    {
    public:
	NoSinkNodeException(int value = 0);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	int errorNo;
    };

    class  NoInputNodeException : public BaseException
    {
    public:
	NoInputNodeException(int value = 0);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	int errorNo;
    };

    class FactoryNotFoundException : public BaseException
    {
    public:
	FactoryNotFoundException(std::string name);
	virtual void print(std::ostream &out = std::cerr) const;

    private:
	std::string factoryName;
    };

}

#endif

/* end of file */
