/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_INPUTSTREAM_H_INCLUDED)
#define HARK_BASE_INPUTSTREAM_H_INCLUDED 1

#include "common.h"

#include "BufferedNode.h"

namespace HARK
{
    class InputStream : public BufferedNode
    {
    protected:
	enum StreamType {
	    fd, fptr, cpp
	};

	int        _outputID;
	int        _inputID;
	StreamType _type;
	int        _retry;

    public:
	InputStream(const std::string &nodeName, const ParameterSet &params);

	void calculate(int output_id, int count, Buffer &out);

    protected:
	InputStream();
	
	NO_ORDER_NODE_SPEEDUP(InputStream)
    };
}

#endif

/* end of file */
