/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_NODEFACTORY_H_INCLUDED)
#define HARK_BASE_NODEFACTORY_H_INCLUDED 1

#include "common.h"

#include "ParameterSet.h"
#include <vector>
#include <string>

namespace HARK
{
    class Node;

    class _NodeFactory
    {
    protected:
	std::string name;

    public:
	_NodeFactory(std::string _name) :
	    name(_name)
	{}

	virtual const std::string &getName()
	{
	    return name;
	}

	virtual Node* Create(const std::string &name, const ParameterSet &parameters) = 0;
	virtual ~_NodeFactory(){}
	
    };

    template <class T>
    class NodeFactory : public _NodeFactory
    {
    public:
	NodeFactory(std::string _name) :
	    _NodeFactory(_name)
	{}

	virtual Node* Create(const std::string &name, const ParameterSet &parameters)
	{
	    return ((Node*) new T(name,parameters));
	}
    };
}

#endif

/* end of file */
