/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#if !defined(HARK_BASE_SLEEP_H_INCLUDED)
#define HARK_BASE_SLEEP_H_INCLUDED 1

#include <atomic>
#include <chrono>
#include <thread>
#include <csignal>

#include "common.h"

#include "Node.h"

namespace HARK
{
    class Sleep : public Node
    {
    public:
	Sleep(const std::string &nodeName, const ParameterSet &params);

	ObjectRef getOutput(int output_id, int count);

    private:
	bool _is_long;
	int _outputID;
	int _usec;
	std::chrono::high_resolution_clock::time_point _start;
    };
}

#endif

/* end of file */
