/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#include "Exception.h"

namespace HARK
{
    NodeNotFoundException::NodeNotFoundException(std::string name) :
	nodeName(name)
    {
    }
    
    void
    NodeNotFoundException::print(std::ostream &out) const
    {
	out << "NodeNotFoundException occured, nodeName: " << this->nodeName << std::endl;
    }
    
    NoSinkNodeException::NoSinkNodeException(int value) :
	errorNo(value)
    {
    }

    void
    NoSinkNodeException::print(std::ostream &out) const
    {
	out << "NoSinkNodeException occured, errorNo: " << this->errorNo << std::endl;
    }

    NoInputNodeException::NoInputNodeException(int value) :
	errorNo(value)
    {
    }

    void
    NoInputNodeException::print(std::ostream &out) const
    {
	out << "NoInputNodeException occured, errorNo: " << this->errorNo << std::endl;
    }

    FactoryNotFoundException::FactoryNotFoundException(std::string name) :
	factoryName(name)
    {
    }

    void
    FactoryNotFoundException::print(std::ostream &out) const
    {
	out << "FactoryNotFoundException occured, factoryName: "<<  this->factoryName << std::endl;
    }
}

/* end of file */
