/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#include "IterCount.h"

namespace HARK
{
    DECLARE_NODE(IterCount);
    /*Node

     * @name IterCount
     * @category Logic
     * @description Get the iterator count (iteration number)

     * @output_name OUTPUT
     * @output_description The iteration count
     * @output_type int

     END*/

    IterCount::IterCount(const std::string &nodeName, const ParameterSet &params) :
	Node(nodeName,params)
    {
        this->_outputID = this->addOutput("OUTPUT");
    }

    ObjectRef
    IterCount::getOutput(int output_id, int count)
    {
        return ObjectRef(Int::alloc(count));
    }

}

/* end of file */
