/*
 * HARK/hark-base
 *
 * Copyright (C) 2008-2018
 *
 */

#include "NOT.h"

namespace HARK
{
    NOT::NOT(const std::string &nodeName, const ParameterSet &params) :
        BufferedNode(nodeName, params)
    {
        this->_inputID  = this->addInput("INPUT");
        this->_outputID = this->addOutput("OUTPUT");
    }

    void
    NOT::calculate(int output_id, int count, Buffer &out)
    {
        ObjectRef inputValue = this->getInput(this->_inputID, count);

        if (dereference_cast<bool> (inputValue)) {
            out[count] = FalseObject;
        } else {
            out[count] = TrueObject;
        }
    }
}

/* end of file */
