#include "operators.h"

#include "Vector.h"
#include "Matrix.h"
#include "Complex.h"
#include <vector>

using namespace HARK;

int main(int argc, char *argv[])
{
    ObjectRef ix = RCPtr<Int>(new Int(10));
    ObjectRef iy = RCPtr<Int>(new Int(20));
    ObjectRef fx = RCPtr<Float>(new Float(10));
    ObjectRef fy = RCPtr<Float>(new Float(20));
    ObjectRef dx = RCPtr<Double>(new Double(10));
    ObjectRef dy = RCPtr<Double>(new Double(20));
    ObjectRef cfx = RCPtr<Complex<float> >(new Complex<float>(std::complex<float>(10, 5)));
    ObjectRef cfy = RCPtr<Complex<float> >(new Complex<float>(std::complex<float>(20, 10)));
    ObjectRef cdx = RCPtr<Complex<double> >(new Complex<double>(std::complex<double>(10, 5)));
    ObjectRef cdy = RCPtr<Complex<double> >(new Complex<double>(std::complex<double>(20, 10)));

    ObjectRef vfx = RCPtr<Vector<float> >(new Vector<float>(3, 10));
    ObjectRef vfy = RCPtr<Vector<float> >(new Vector<float>(3, 20));
    ObjectRef vdx = RCPtr<Vector<double> >(new Vector<double>(3, 10));
    ObjectRef vdy = RCPtr<Vector<double> >(new Vector<double>(3, 20));

    ObjectRef vcfx = RCPtr<Vector<std::complex<float> > >(new Vector<std::complex<float> >(3, 10));
    ObjectRef vcfy = RCPtr<Vector<std::complex<float> > >(new Vector<std::complex<float> >(3, 20));
    ObjectRef vcdx = RCPtr<Vector<std::complex<double> > >(new Vector<std::complex<double> >(3, 10));
    ObjectRef vcdy = RCPtr<Vector<std::complex<double> > >(new Vector<std::complex<double> >(3, 20));

    ObjectRef mfx = RCPtr<Matrix<float> >(new Matrix<float>(3, 2));
    ObjectRef mfy = RCPtr<Matrix<float> >(new Matrix<float>(3, 2));
    ObjectRef mdx = RCPtr<Matrix<double> >(new Matrix<double>(3, 2));
    ObjectRef mdy = RCPtr<Matrix<double> >(new Matrix<double>(3, 2));

    ObjectRef mcfx = RCPtr<Matrix<std::complex<float> > >(new Matrix<std::complex<float> >(3, 2));
    ObjectRef mcfy = RCPtr<Matrix<std::complex<float> > >(new Matrix<std::complex<float> >(3, 2));
    ObjectRef mcdx = RCPtr<Matrix<std::complex<double> > >(new Matrix<std::complex<double> >(3, 2));
    ObjectRef mcdy = RCPtr<Matrix<std::complex<double> > >(new Matrix<std::complex<double> >(3, 2));

    {
	ObjectRef x = ix;
	ObjectRef y = iy;
	ObjectRef z = concat(x, y);
	std::cout << x << " concat " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = RCPtr<String>(new String("123"));
	ObjectRef y = RCPtr<String>(new String("456"));
	ObjectRef z = concat(x, y);
	std::cout << x << " concat " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = ix;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = ix;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = ix;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = fx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = dx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cfx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cfx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cfx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = cdx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cdx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cdx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = cfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = cfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = cfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = cdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = cdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = cdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cfx;
	ObjectRef y = cfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cdx;
	ObjectRef y = cfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = cfx;
	ObjectRef y = cdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = cdx;
	ObjectRef y = cdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vfx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vfx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vfx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vdx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vfx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vfx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vcfx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcfx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcfx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vcdx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcdx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcdx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcfx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcdx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vcfx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcdx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vcfx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcfx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vcdx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcdx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vfx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vfx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcfx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcfx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vcdx;
	ObjectRef y = vfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vcdx;
	ObjectRef y = vdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vfx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = vcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = vfx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = vdx;
	ObjectRef y = vcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mfx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mfx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mfx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mdx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mfx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mfx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mcfx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcfx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcfx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mcdx;
	ObjectRef y = iy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcdx;
	ObjectRef y = fy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcdx;
	ObjectRef y = dy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = ix;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = fx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = dx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcfx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcdx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mcfx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcdx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mcfx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcfx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mcdx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcdx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mfx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mfx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcfx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcfx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mcdx;
	ObjectRef y = mfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mcdx;
	ObjectRef y = mdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mfx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = mcfy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }

    {
	ObjectRef x = mfx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    {
	ObjectRef x = mdx;
	ObjectRef y = mcdy;
	ObjectRef z = (x + y);
	std::cout << x << " + " << y << " = " << z << std::endl;
    }
    
    return 0;
}
